package com.esterel.qvto.test.executor;


import java.io.OutputStreamWriter;


import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.URI;
import org.eclipse.m2m.qvt.oml.ExecutionContextImpl;
import org.eclipse.m2m.qvt.oml.ExecutionDiagnostic;
import org.eclipse.m2m.qvt.oml.TransformationExecutor;
import org.eclipse.m2m.qvt.oml.util.Log;
import org.eclipse.m2m.qvt.oml.util.WriterLog;
import org.eclipse.m2m.qvt.oml.examples.blackbox.*;

public class ExecutorTest {

	public static void main(String[] args) {
		//Register Blackbox Class
		TransformationExecutor.BlackboxRegistry.INSTANCE.registerModules(UtilitiesLibrary.class);
		//Define Transformation executor
		String transPath = "C:\\path\\NewTransformation.qvto";
		URI transformationURI = URI.createFileURI(transPath);
		TransformationExecutor executor = new TransformationExecutor(transformationURI);
		//Define Context for execution
		//Print log() messages
		ExecutionContextImpl context = new ExecutionContextImpl();
		OutputStreamWriter outStream = new OutputStreamWriter(System.out);
		Log log = new WriterLog(outStream);
		context.setLog(log);
		
		ExecutionDiagnostic result = executor.execute(context);
		
		// check the result for success
		if(result.getSeverity() == Diagnostic.OK) {
			System.out.println("OK");
		} else {
			IStatus status = BasicDiagnostic.toIStatus(result);
			System.out.println(status.getMessage());
			for(IStatus s: status.getChildren())
				System.out.println(s.getMessage());
		}
	}
		


}
